EnumDeserializer
Date: 2016-12-04

com.fasterxml.jackson.databind.deser.std

## Class EnumDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer<java.lang.Object>
      - - com.fasterxml.jackson.databind.deser.std.EnumDeserializer

- All Implemented Interfaces:
    java.io.Serializable

      public class EnumDeserializer
      extends StdScalarDeserializer<java.lang.Object>

  Deserializer class that can deserialize instances of specified Enum class from Strings and Integers.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.Object[]` | `_enumsByIndex`
    `protected CompactStringObjectMap` | `_lookupByName`
    `protected CompactStringObjectMap` | `_lookupByToString` Alternatively, we may need a different lookup object if "use toString" is defined.

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EnumDeserializer(EnumResolver byNameResolver)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.lang.Object` | `_deserializeOther(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
    `protected java.lang.Class<?>` | `_enumClass()`
    `protected CompactStringObjectMap` | `_getToStringLookup(DeserializationContext ctxt)`
    `java.lang.Object` | `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `static JsonDeserializer<?>` | `deserializerForCreator(DeserializationConfig config, java.lang.Class<?> enumClass, AnnotatedMethod factory)` Deprecated. Since 2.8
    `static JsonDeserializer<?>` | `deserializerForCreator(DeserializationConfig config, java.lang.Class<?> enumClass, AnnotatedMethod factory, ValueInstantiator valueInstantiator, SettableBeanProperty[] creatorProps)` Factory method used when Enum instances are to be deserialized using a creator (static factory method)
    `static JsonDeserializer<?>` | `deserializerForNoArgsCreator(DeserializationConfig config, java.lang.Class<?> enumClass, AnnotatedMethod factory)` Factory method used when Enum instances are to be deserialized using a zero-/no-args factory method
    `boolean` | `isCachable()` Because of costs associated with constructing Enum resolvers, let's cache instances by default.

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer

      `deserializeWithType`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_coerceIntegral, _deserializeFromEmpty, _failDoubleToIntCoercion, _hasTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _parseBoolean, _parseBooleanFromInt, _parseBooleanFromOther, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, getValueClass, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserialize, findBackReference, getDelegatee, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullValue, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _enumsByIndex

          protected java.lang.Object[] _enumsByIndex

    - #### _lookupByName

          protected final CompactStringObjectMap _lookupByName

      Since:
        2.7.3

    - #### _lookupByToString

          protected CompactStringObjectMap _lookupByToString

      Alternatively, we may need a different lookup object if "use toString" is defined.
      Since:
        2.7.3

  - ### Constructor Detail

    - #### EnumDeserializer

          public EnumDeserializer(EnumResolver byNameResolver)

  - ### Method Detail

    - #### deserializerForCreator

          @Deprecated
          public static JsonDeserializer<?> deserializerForCreator(DeserializationConfig config,
                                                              java.lang.Class<?> enumClass,
                                                              AnnotatedMethod factory)

      Deprecated. Since 2.8

    - #### deserializerForCreator

          public static JsonDeserializer<?> deserializerForCreator(DeserializationConfig config,
                                                   java.lang.Class<?> enumClass,
                                                   AnnotatedMethod factory,
                                                   ValueInstantiator valueInstantiator,
                                                   SettableBeanProperty[] creatorProps)

      Factory method used when Enum instances are to be deserialized using a creator (static factory method)
      Returns:
        Deserializer based on given factory method
      Since:
        2.8

    - #### deserializerForNoArgsCreator

          public static JsonDeserializer<?> deserializerForNoArgsCreator(DeserializationConfig config,
                                                         java.lang.Class<?> enumClass,
                                                         AnnotatedMethod factory)

      Factory method used when Enum instances are to be deserialized using a zero-/no-args factory method
      Returns:
        Deserializer based on given no-args factory method
      Since:
        2.8

    - #### isCachable

          public boolean isCachable()

      Because of costs associated with constructing Enum resolvers, let's cache instances by default.
      Overrides:
        `isCachable` in class `JsonDeserializer<java.lang.Object>`

    - #### deserialize

          public java.lang.Object deserialize(com.fasterxml.jackson.core.JsonParser p,
                                     DeserializationContext ctxt)
                                       throws java.io.IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (jp.getCurrentToken() == JsonToken.START_OBJECT) {
                   jp.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<java.lang.Object>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `java.io.IOException`

    - #### _deserializeOther

          protected java.lang.Object _deserializeOther(com.fasterxml.jackson.core.JsonParser p,
                                           DeserializationContext ctxt)
                                                throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _enumClass

          protected java.lang.Class<?> _enumClass()

    - #### _getToStringLookup

          protected CompactStringObjectMap _getToStringLookup(DeserializationContext ctxt)